/*	MIRS9903
 *	defs.h	: Defines header file
 *	Version	0.04
 *	by taguchi 2000/09/13
 *	by okamoto 2000/10/27
 *
 *	History
 *	0.04 2000/10/27 LED_TimeIvȂǃ^C}[Ԋu
 *	0.03 2000/09/13	E^C̒aʉ
 *	0.02 2000/09/06	^CԊuAaύX
 *	0.01 2000/07/19	
 */

#define MAXTSK 13	/* the number of task */
#define BB_MAX 10	/* the number of BB */

#define TIMER_MMI 3	/* Time interval of MMI timer task */
#define LED_TimeIv 10	/* Time interval of LED_ */
#define TIMER_RE  3	/* Time interval of RE timer task */
#define TIMER_PWM 3	/* Time interval of PWM timer task */
#define TIMER_IRS 5	/* Time interval of IRS timer task */
#define TIMER_SHU 6	/* Time interval of ȈʒuC timer task */

#define PY_MMI	2	/* Priority of MMI task */
#define PY_USS	3	/* Priority of USS task */
#define PY_JIK	3	/* Priority of Ȉʒuo task */
#define PY_PWM	1	/* Priority of PWM task */
#define PY_KOU	6	/* Priority of sv task */
#define PY_SHU	2	/* Priority of ȈʒuC task */
#define PY_TRC	4	/* Priority of OgX task */
#define PY_TST	5	/* Priority of s task */
#define PY_KAK	4	/* Priority of lA task */
#define PY_KID	6	/* Priority of O task */

#define TRUE	1	/* True */
#define FALSE	0	/* False */

#define USS0	0	/* USS channel #0 (back)*/
#define USS1	1	/* USS channel #1 (left)*/
#define USS2	2	/* USS channel #2 (front)*/
#define USS3	3	/* USS channel #3 (right)*/

#define TSF	1	/* Touch sensor Front */
#define TSR	4	/* Touch sensor Right */
#define TSL	2	/* Touch sensor Left */


#define EOM	999	/* End of Map	*/

#define PI	3.14159265359f	/* Pai ()	*/
#define PI2	(PI*2.f)	/* 2		*/
#define PIH	(PI/2.f)	/* /2		*/

#define DT	0.03f		/* task02 period[sec] */
#define PPR	6400.0f	     	/* pulse every revolution [pulse/r] 	*/

#define D_R	0.07400f	/* diameter of tyre[m] 			*/
#define D_L	0.07400f
#define B_CWR	0.1200f 		/* ^CԊûP^Q [m] for CW---- */
#define B_CWL	0.1200f

#define COEF	((PIH*D_R)/(PPR*DT))
#define COEF_R	((PIH*D_R)/(PPR*DT))	/* w/pulse			*/
#define COEF_L	((PIH*D_L)/(PPR*DT))


/* -------------------------------------------------------------------- */

#define ABS(x)		(((x)<0)?-(x):(x))	/* Βl 		     */
#define BIT_R(x,y) 	((x>>y)&1)		/* x  y bitڂ bit Ԃ */
#define BIT_W(x,y,z)	x=(((z&1)==0)?(x&(-1-(1<<y))):(x|(1<<y))) 
						/* x  y bitڂ z ɂ   */

#define SET_VAL(x,y,z)	*((int *)sys9(x,y))=z	/* *(BB(x,y))  z */
#define DISP_SET(x,y)	SET_VAL(0,x,y)		/* MMILED\Zbg*/
#define LED_SET(x)	SET_VAL(0,6,x)		/* MMIRGLED_Zbg*/
#define GET_VAL(x,y)	*((int *)sys9(x,y))	/* *(BB(x,y)) 𓾂*/
#define LED_GET()	GET_VAL(0,6)		/* MMILED\擾*/


/* --used in task08,09,10------------------------------------------------ */
#define FORWARD 40,40		/*duty`*/
#define BACK    -40,-40
#define ROAT_R  -40,40
#define ROAT_L  40,-40
#define TURN_R  35,77
#define TURN_L  77,35
#define TURN_RB -30,-87
#define TURN_LB -87,-30

#define DELTA_TH 3		/*px덷͈[x]*/
#define DELTA_R  5		/*W덷͈(a)[cm]*/
#define DELTA_USS 10		/*W덷͈(g)*/

#define RAD(x)	(x*(PI/180.0f))
#define DEG(x)	(x*(180.0f/PI))


