/**********************************************
* MIRS9903 Task00 : Man Machine Interface Task 
* 				Programmed by Chihiro Taguchi  
* 				Debugged   by Masao Okamoto    
*	Ver1.04 last update 2001/1/19
*			8/28	First Version
*			8/31	7segLED\mF
*			9/12	LED_ŕ\mF
*			10/13	ǉAdefs.hCN[h
*			11/16	LED_œ̏C
*			1/19	e
***********************************************
* Manual(Command)
* 	for Normal Task
* 		cm	scm	
* 		 1	 n	\BB̐ݒ(n3`4̐:2^XNԍA2BBԍ)
* 		 2	 n	LED_Ԃ̐ݒ(n2̐:0ŏA1œ_A2œ_ł\Aԗ΂̏œo^)
* 		 4	 n	{^ݒ(n1ŊA0Ŋs)
* 		 5	 n	BBȊO̕\Ŏgpn̓f[^)
* Data of BB
* 	BB_num	
* 	   0		\f[^1(\)
* 	   1		\f[^2(\)
* 	   2		\f[^3(\)
* 	   3		\f[^4(\)
* 	   4		\ĂBB̔ԍ
* 	   5		gpĂȂ
* 	   6		LED_Ԃ̐ݒ
* 	   7		{^XCb`̊ݒ
* 	   8		[^[XCb`̒l
* 	   9		{^XCb`̉ꂽ
**********************************************/
#include "mirx68k.h"
#include "hard.h"
#include "defs.h"

static int led_status;
static int led_f,led_tf;
static int t_count;	/* timer_count */

void inzt00(){
	int i;
	sys0(0,0x1111);		/* ^XN̏ݒ */
	mmi_init();			/* MMȈ */

	sys8(0,0,0);	/* \f[^[1]	*/
	sys8(0,1,0);	/* \f[^[2]	*/
	sys8(0,2,0);	/* \f[^[3]	*/
	sys8(0,3,0);	/* \f[^[4]	*/
	sys8(0,4,0);	/* \BB		*/
	sys8(0,5,0);	/* 	*/
	sys8(0,6,0);	/* ԗLED̏	*/
	sys8(0,7,0);	/* vbVXCb`tO	*/
	sys8(0,8,0);	/* [^[XCb`̒l	*/
	sys8(0,9,0);	/* {^͉̓		*/

	led_f=led_tf=0;

	sys2(0,TIMER_MMI,0,0);		/* ^C}[^XN̓o^ */
	sys4(0);
	sys5(0,1,BTN_INT_VCT,0,0);	/* 荞݃^XNo^   */
	btn_disable_int();		/* {^XCb`̊荞݂֎~ */
	sys3(0,0);
}

void nrmt00(int cm,int scm){
	switch(cm){
		case 1: sys8(0,4,scm);	/* \BB̐ݒ */
			break;
		case 2:	sys8(0,6,scm);	/* ԗLED ̐ݒ */
			led_f=1;
			break;
		case 4:	sys8(0,7,scm);	/* {^XCb`ݒ */
			if(scm==1){
				btn_enable_int();
			}else if(scm==0){
				btn_disable_int();
			}
			break;
		case 5:	sys8(0,0,scm);	/* \f[^(BBȊO) */
			sys8(0,4,0);
			break;
		case 6:	sys8(0,9,scm);	/* {^XCb`񐔂w肷 */
			break;
		default:
			break;
	}
}

void timt00(int cm,int scm){
	int dip;		/* [^[XCb`	*/
	int val;		/* \鐔l		*/
	int led_s,led_r,led_g;	 
	int bb_num=sys9(0,4);
	int tn=bb_num/100;
	int bbn=bb_num%100;	/* ^XNBB̔ԍ	*/

	if(tn>=MAXTSK){/*BB̓e\*/
		tn=0;
	}
	
	if(bbn>BB_MAX){
		bbn=0;
	}
	
	val=sys9(tn,bbn);
	led_set_all(val);

	dip = dipsw_data();	/* [^[XCb`̒lǂݍ */
	sys8(0,8,dip);		/* BBɃf[^ */

	if(led_f){
		led_s=sys9(0,6);
		led_r=led_s/10;
		led_g=led_s%10;
		
		if(led_r==2 || led_g==2){
			led_on(OFF);
			led_tf=20;
		}else{
			led_tf=0;
		}
		switch(led_s){
			case 00: led_on(OFF);break;
			case 01: led_on(GREEN);break;
			case 10: led_on(RED);break;
			case 11: led_on(GREEN|RED);break;
		}
		led_f=0;
	}else if(led_tf==1){
		led_s=sys9(0,6);
		switch(led_s){
			case 20: 
			case 02: led_on(OFF);break;
			case 22: 
			case 21: led_on(GREEN);break;
			case 12: led_on(RED);break;
		}
		led_tf=2*LED_TimeIv;
	}else if(led_tf==LED_TimeIv){
		led_s=sys9(0,6);
		switch(led_s){
			case 22: 
			case 20: led_on(RED);break;
			case 02: led_on(GREEN);break;
			case 21: 
			case 12: led_on(RED|GREEN);break;
		}
		led_tf--;
	}else if(led_tf>=1){
		led_tf--;
	}
}

interrupt void intt00()
{
	int p;
	btn_disable_int();

	p=sys9(0,9);
	p++;
	sys8(0,9,p);

	btn_enable_int();
}
