/************************************************/
/*                                              */
/*   Program for Ultra Sound Sensors task01.c   */
/*                        on September 5,2000   */
/*                Programmed by Masao Okamoto   */
/*                                              */
/************************************************/
#include "mirx68k.h"
#include"hard.h"

#define USS_MAX 4

static int uss_no[USS_MAX+1];
static int t_f;
static int s_channel;
static int uss_no_select;

void inzt01()
{
	int i;
	
	uss_init();
	
	t_f=0;
	s_channel=0;
	uss_no_select=0;
	
	sys0(1,0x1111);
	sys2(1,15,0,0);
	sys4(1);
	sys5(1,0,USS_INT_VCT,0,0);
	sys10(1);
	
	sys8(1,0,0);
	sys8(1,1,0);
	sys8(1,2,0);
	sys8(1,3,0);
	sys8(1,4,0);
	sys8(1,5,0);
	sys8(1,6,0);
	sys8(1,7,0);
	sys8(1,8,0);
	sys8(1,9,0);
	
	for(i=0;i<=USS_MAX;i++){
		uss_no[i]=USS_MAX;
	}
}

void nrmt01(int cm,int scm){
	uss_stop();
	if(scm<4000){
		uss_no[0]=scm/1000;
		uss_no[1]=(scm/100)%10;
		uss_no[2]=(scm/10)%10;
		uss_no[3]=scm%10;
	}
	
	if(cm==1){
		t_f=0;
	}else if(cm==2){
		t_f=1;
	}
	
	if(uss_no[0]<USS_MAX){
		sys11(1);
		s_channel=uss_no[0];
		uss_no_select=0;
		uss_start(s_channel);
		sys3(1,0);
	}
}

void timt01(int cm,int scm)
{
	int i;

	if(t_f){
		uss_no_select++;
		if(uss_no_select>=USS_MAX){
			uss_no_select=0;
		}else if(uss_no[uss_no_select]>=USS_MAX){
			uss_no_select=0;
		}
		s_channel=uss_no[uss_no_select];
		uss_start(s_channel);
	}else{
		for(i=0;i<USS_MAX;i++){
			uss_no[i]=uss_no[i+1];
		}
		if(uss_no[0]!=USS_MAX){
			s_channel=uss_no[0];
			uss_start(s_channel);
		}else{
			sys10(1);
			uss_stop();
			rs_snd("USS STOP\n");
			sys4(1);
		}
	}
}

interrupt void intt01()
{
	int distance;
	if(uss_chk_int()){
		uss_stop();
		if(uss_chk_conect()){  
			distance=(s_channel)*1000+999;
		}else{  
			distance=(s_channel)*1000+uss_data();
		}
		sys8(1,s_channel,distance);
	}
}