/*
**	MIRS9903
**	task02.c  :ȈʒuoTask
**			(RE&TS data read and calculate...)
**			[^[GR[_[(Rotary Encoder)
**			^b`ZT(Touch Sensor)
**	Version	1.04  (2001/1/16)
**		by taguchi
**
**	history :
**	Ver	1.07	2001/1/16	Delete program for collecting data
**	Ver	1.06	2000/9/13	Add KW_CCWR,L KW_CWR,L
**					COEF etc.
**					Change calculate v,w
**	Ver	1.05	2000/9/6	change x,y calculate 
**					Add BB (using task11 BB)
**	Ver	1.04	2000/8/3	Add RAD(x),change Normal task
**					BB6 not use
**					add all_pulse&r_data
**	Ver	1.03	2000/7/27	Add cm2 and cm3 in Normal task
**					Delete n
**	Ver	1.02	2000/7/25	Delete old,flag,ussf,cm2
**	Ver	1.01	2000/7/19	First version
*/

/************************************************************************/

/*֐,ϐ̐ݒ*/
#include "mirx68k.h"  		/* MIRX68K */
#include "hard.h"		/* Hardware function library */
#include "defs.h"

#define dx 0.0005

#define Kv	COEF		/* x̌W */
#define Kw_CCWR	(COEF_R/(B_CWR+dx))	
#define Kw_CCWL	(COEF_L/(B_CWL+dx))		/* omega(turn left̎)̌W */

#define INIT_X	 0.0f		/* xW(Initial X-coordinate) */
#define INIT_Y	-133.0f 	/* yW(Initial Y-coordinate) */
#define INIT_TH	 PIH		/* pp(Initial Theta coordinate) */


extern float cosf(float);		/* cos(x)̌vZ(cosinus function) */
extern float sinf(float);		/* sin(x)̌vZ(sinus function) */

static float	x_thre=135.0f;		/* xW̍ől(x-axis limit) */
static float	y_thre=135.0f;		/* yW̍ől(y-axis limit) */

static float	re_x=INIT_X;		/* xW[cm] */
static float	re_y=INIT_Y;		/* yW[cm] */
static float	re_th=INIT_TH;		/* pp[rad] */
static float	w;			/* px(omega)[rad/sec] */
static float 	len;			/* ړ */
static int	Roat;			/*pp]*/

/*************************************************************************************/
/*^XN*/

void inzt02()			/* ݒ^XN */
{
	sys0(2,0x1110);			/* task02̃^XNݒ */
	sys8(2,0,(int)(INIT_X));		/* xWf[^̐ݒ(ʒu) */
	sys8(2,1,(int)(INIT_Y));		/* YWf[^̐ݒ(ʒu) */
	sys8(2,2,(int)(DEG(INIT_TH)));		/* ppf[^̐ݒ(ʒu) */
	sys8(2,3,0);		/* E[^GR[_[(RE)f[^(pX) */
	sys8(2,4,0);		/* REf[^(pX) */
	sys8(2,5,0);		/* ^b`ZT(TS) f[^ */
	sys8(2,6,0);		/* pp] */
	sys8(2,7,0);		/* x */
	sys8(2,8,0);		/* px */
	sys8(2,9,0);		/* ړ */
	
	sys2(2,TIMER_RE,0,0);	/* ^C}[^XN̋NԃZbg */
	sys4(2);		/* ^C}[Xgbv */

	w=0;		
	len=0;
	re_ts_data();		/* RETSf[^ */
	Roat=0;
	
	sys3(2,1);		/* ^C}[^XNJEgX^[g(JEgl0ɂ) */
}


void nrmt02(int cm,int scm)		/* m[}^XN */
{
	float to_float;		/*change from int data to float data*/
	
	if(cm==1){		/* x,yWƊpxĐݒ */
		re_x = (float)scm;
	}else if(cm==2){
		re_y = (float)scm;
	}else if(cm==3){
		to_float=(float)scm;
		re_th= RAD(to_float);
	}else if(cm==4){		/*pp]̍Đݒ*/
		Roat=scm;
	}
}


void timt02(int cm, int scm)		/* ^C}[^XN */
{
	RE_TS_DATA	data;		/* RE.rRE.lTSf[^̍\(RE and TS data) */
	float	v;		/* x[m/s] */
	float	w_old;			/* ߋ̊px */
	int ts_in;		/* TSf[^ݗp(TS input data) */


	data=re_ts_data();			/* RE&TSf[^ǂݍ */
	ts_in=0;
	BIT_W(ts_in,0,BIT_R(data.ts,0));	/* TS̓̓f[^H */
	BIT_W(ts_in,1,BIT_R(data.ts,1));
	BIT_W(ts_in,2,BIT_R(data.ts,2));
	sys8(2,5,ts_in);			/* BBTSf[^ */

	v = (float)(COEF_R*data.r+COEF_L*data.l);		/* x̌vZ */
	v = v*(100.f);
	w_old = w;				/* O̊pxf[^ۑ */
	w = Kw_CCWR*(float)data.r-Kw_CCWL*(float)data.l;	/* px̌vZ */
	re_th += ((w+w_old)*DT)/2.f;		/* pxpx߂(ςƂĂ) */
	
	len+=(v*DT);		/* ړʂ̌vZ */

	/* re_th+=(w*DT); */
	while(re_th<0.f){		/* px0`2΂܂łɂ */
		re_th += PI2;
		Roat--;
	}
	while(re_th>=PI2){
		re_th -= PI2;
		Roat++;
	}
	if(Roat>100){		/*for safe*/
		Roat=0;
	}else if(Roat<-100){
		Roat=0;
	}
	
	re_x += (v*DT*cosf(re_th));		/* xW̌vZ */
	re_y += (v*DT*sinf(re_th));		/* yW̌vZ */
	
	if(re_x >  x_thre) re_x =  x_thre;		/* x,yWlimitɐ */
	if(re_x < -x_thre) re_x = -x_thre;
	if(re_y >  y_thre) re_y =  y_thre;
	if(re_y < -y_thre) re_y = -y_thre;
	

	sys8(2,0,(int)(re_x));		/* BBxWAyWApp */
	sys8(2,1,(int)(re_y));
	sys8(2,2,(int)(DEG(re_th)));
	sys8(2,3,(int)data.r);		/* BBɍEړ */
	sys8(2,4,(int)data.l);
/*	sys8(2,5,ts_in);		write Touch Sensor(TS) data */
	sys8(2,6,Roat);			/* BBɎpp] */
	sys8(2,7,(int)(v));		/* BBɑxApxAړʂ */
	sys8(2,8,(int)(DEG(w)));
	sys8(2,9,((int)len));
}


interrupt void intt02(){
}

